<?php
/**
 * @version     1.0.0
 * @package     com_docebo
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Docebo Srl. <info@docebo.com> - http://www.docebo.com
 */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

/**
 * Docebo model.
 */
class DoceboModelgeneralsettingFull extends JModelAdmin {
	/**
	 * @var        string    The prefix to use with controller messages.
	 * @since    1.6
	 */
	protected $text_prefix = 'COM_DOCEBO';


	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param    type    The table type to instantiate
	 * @param    string    A prefix for the table class name. Optional.
	 * @param    array    Configuration array for model. Optional.
	 *
	 * @return    JTable    A database object
	 * @since    1.6
	 */
	public function getTable($type = 'Generalsetting', $prefix = 'DoceboTable', $config = array()) {
		return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Method to get the record form.
	 *
	 * @param    array   $data An optional array of data for the form to interogate.
	 * @param    boolean $loadData True if the form is to load its own data (default case), false if not.
	 *
	 * @return    JForm    A JForm object on success, false on failure
	 * @since    1.6
	 */
	public function getForm($data = array(), $loadData = TRUE) {
		// Initialise variables.
		$app = JFactory::getApplication();

		// Get the form.
		$form = $this->loadForm('com_docebo.generalsetting', 'generalsetting', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return FALSE;
		}

		return $form;
	}

	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return    mixed    The data for the form.
	 * @since    1.6
	 */
	protected function loadFormData() {
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_docebo.edit.generalsetting.data', array());

		if (empty($data)) {
			$data = $this->getItem();

		}

		return $data;
	}

	/**
	 * Method to get a single record.
	 *
	 * @param    integer    The id of the primary key.
	 *
	 * @return    mixed    Object on success, false on failure.
	 * @since    1.6
	 */
	public function getItem($pk = NULL) {
		if ($item = parent::getItem($pk)) {

			//Do any procesing on fields here if needed

		}

		return $item;
	}


}

/*
 * Two versions of the same class are defined conditionally below,
 * because Joomla parent/core classes used to define optional/default values
 * to parameters by reference (&$table) prior to v3 and by value only ($table)
 * afterwards, which causes overwriting methods to display PHP warnings
 * when STRICT error reporting is enabled (on by default in PHP 5.4).
 */
if (substr(JVERSION, 0, 1) >= 3) {
	class DoceboModelgeneralsetting extends DoceboModelgeneralsettingFull {

		/**
		 * Prepare and sanitise the table prior to saving.
		 *
		 * @since    1.6
		 */
		protected function prepareTable($table) {

			jimport('joomla.filter.output');

			if (empty($table->id)) {

				// Set ordering to the last item if not set
				if (@$table->ordering === '') {
					$db = JFactory::getDbo();
					$db->setQuery('SELECT MAX(ordering) FROM #__docebo_general_settings');
					$max             = $db->loadResult();
					$table->ordering = $max + 1;
				}

			}
		}
	}
} else {

	// If your IDE is giving a warning that the class "DoceboModelgeneralsetting"
	// is already defined, ignore it. It is defined only once depending on if/else.
	class DoceboModelgeneralsetting extends DoceboModelgeneralsettingFull {

		/**
		 * Prepare and sanitise the table prior to saving.
		 *
		 * @since    1.6
		 */
		protected function prepareTable(&$table) {

			jimport('joomla.filter.output');

			if (empty($table->id)) {

				// Set ordering to the last item if not set
				if (@$table->ordering === '') {
					$db = JFactory::getDbo();
					$db->setQuery('SELECT MAX(ordering) FROM #__docebo_general_settings');
					$max             = $db->loadResult();
					$table->ordering = $max + 1;
				}

			}
		}
	}
}